unit Ackermann;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Spin;

type
  TAcker = class(TForm)
    LabelX: TLabel;
    LabelFn: TLabel;
    Tiefe: TLabel;
    LabelTiefe: TLabel;
    FiboBild: TImage;
    EingabeX: TSpinEdit;
    Rechne: TButton;
    Ausgabe: TListBox;
    LabelY: TLabel;
    EingabeY: TSpinEdit;
    procedure RechneClick(Sender: TObject);
    function AK(X,Y:Extended):Extended;
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Acker: TAcker;

implementation

{$R *.DFM}
{$M 16384,134217728} // Stackgre(2^14, 2^27)
 var count:Extended;

 function TAcker.AK(X,Y:Extended):Extended;
  begin
   Count:=Count+1.0;
   if Frac(Count/100)=0.0 then Application.ProcessMessages; // Programmabbruch
   if X=0 then AK:=Y+1
   else if Y=0 then AK:=AK(X-1,1)
        else AK:=AK(X-1,AK(X,Y-1));
  end;

 procedure TAcker.RechneClick(Sender: TObject);
  var X,Y:Integer;
      Erg:Extended;
  begin
   X:=EingabeX.Value;
   Y:=EingabeY.Value;
   Count:=0;Ausgabe.Clear;
   Screen.Cursor:=crHourGlass;
   LabelTiefe.Visible:=True;
   Tiefe.Visible:=True;
   Erg:=AK(X,Y);
   Screen.Cursor:=crDefault;
   Ausgabe.Items.Add(Format('%0.0f',[Erg]));
   Tiefe.Caption:=Format('%0.0f',[Count]);
  end;

 procedure TAcker.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  begin
   if MessageDlg('Die Berechnung abgebrechen?',mtConfirmation,[mbYes,mbNo],0)=mrYes then
    begin
     MessageDlg('Die Ackermannfunktion wird abgebrochen!',mtWarning,[mbOk],0);
     CanClose:=True;Halt
    end
   else CanClose:=False
  end;

end.
