unit BitmapDreh;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Spin;

type
  TBildDrehen = class(TForm)
    Image1: TImage;
    Drehen90: TButton;
    Drehen180: TButton;
    Drehen270: TButton;
    procedure Drehen90Click(Sender: TObject);
    procedure Drehen180Click(Sender: TObject);
    procedure Drehen270Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  BildDrehen: TBildDrehen;

implementation

{$R *.DFM}
{$R+,Q+}

 procedure Drehen90Grad(BitMap:TBitmap);
  var x,y,b,h:Integer;
      RowOut,RowIn:PIntegerArray;
      Help:TBitmap;
  BEGIN
   BitMap.PixelFormat:=pf32bit;
   Help:=TBitmap.Create;
   Help.PixelFormat:=pf32bit;
   b:=BitMap.Height;
   h:=BitMap.Width;
   Help.Width:=b;
   Help.Height:=h;
   RowIn:=BitMap.scanline[b-1];
   for y:=0 to (h-1) do
    begin
     RowOut:=Help.ScanLine[y];
     for x:=0 to (b-1) do
      Rowout[x]:=RowIn[y+x*h];
    end;
   BitMap.Assign(Help); // Help --> BitMap
   Help.Free;
  end;

 procedure Drehen180Grad(Bitmap:TBitmap);
  var x,y:Integer;
    RowIn,RowOut:PIntegerArray;
    Help:TBitmap;
  begin
   BitMap.PixelFormat:=pf32bit;
   Help:=TBitmap.Create;
   Help.PixelFormat:=pf32bit;
   Help.Width:=Bitmap.Width;
   Help.Height:=Bitmap.Height;
   for y:=0 to Bitmap.Height-1 do
    begin
     RowIn:=Bitmap.ScanLine[y];
     RowOut:=Help.ScanLine[Bitmap.Height-y-1];
     for x:=0 to Bitmap.Width-1 do RowOut[Bitmap.Width-x-1]:=RowIn[x]
    end;
   Bitmap.Assign(Help);
   Help.Free;
  end;

 procedure TBildDrehen.Drehen90Click(Sender: TObject);
  begin
   Screen.Cursor:=crHourGlass;
   Drehen90Grad(Image1.Picture.BitMap);
   Screen.Cursor:=crDefault;
  end;

 procedure TBildDrehen.Drehen180Click(Sender: TObject);
  begin
   Screen.Cursor:=crHourGlass;
   Drehen180Grad(Image1.Picture.BitMap);
   Screen.Cursor:=crDefault;
  end;

 procedure TBildDrehen.Drehen270Click(Sender: TObject);
  begin
   Screen.Cursor:=crHourGlass;
   Drehen180Grad(Image1.Picture.BitMap);
   Drehen90Grad(Image1.Picture.BitMap);
   Screen.Cursor:=crDefault;
  end;

end.

