unit Fibonacci;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, ExtCtrls;

type
  TFibonaccifolge = class(TForm)
    Eingabe: TSpinEdit;
    LabelN: TLabel;
    LabelFn: TLabel;
    Rechne: TButton;
    Tiefe: TLabel;
    LabelTiefe: TLabel;
    Wahl: TRadioGroup;
    FiboBild: TImage;
    Ausgabe: TListBox;
    procedure RechneClick(Sender: TObject);
    function Fibo(AN:Extended):Extended;
    procedure WahlClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Fibonaccifolge: TFibonaccifolge;

implementation

{$R *.DFM}
{$R+,Q+}
var count:Extended;

function TFibonaccifolge.Fibo(AN:Extended):Extended;
 begin
  Count:=Count+1.0;
  if AN<2 then Fibo:=1.0 else Fibo:=Fibo(AN-1)+Fibo(AN-2)
 end;

procedure TFibonaccifolge.RechneClick(Sender: TObject);
 var K,N:Integer;
     F:Array of Extended;
     Erg:Extended;
 begin
  N:=Eingabe.Value;
  Count:=0;Ausgabe.Clear;
  Screen.Cursor:=crHourGlass;
  if Wahl.ItemIndex=0 then
   begin
    LabelTiefe.Visible:=True;
    Tiefe.Visible:=True;
    Erg:=Fibo(N);
    Ausgabe.Items.Add(Format('%0.0f',[Erg]));
    Tiefe.Caption:=Format('%0.0f',[Count]);
   end;
  if Wahl.ItemIndex=1 then
   begin
    LabelTiefe.Visible:=False;
    Tiefe.Visible:=False;
    SetLength(F,N+1);
    F[0]:=1;
    Ausgabe.Items.Add(Format('%0.0f',[F[0]]));
    F[1]:=1;
    Ausgabe.Items.Add(Format('%0.0f',[F[0]]));
    for K:=2 to N do
     begin
      F[K]:=F[K-1]+F[K-2];
      Ausgabe.Items.Add(Format('%0.0f',[F[K]]));
     end;
   end;
  if Wahl.ItemIndex=2 then
   begin
    inc(n);
    if Odd(n) then Erg:=1/sqrt(5)*(exp(n*Ln((1+sqrt(5))/2))-exp(n*Ln(abs(1-sqrt(5))/2)))
    else Erg:=1/sqrt(5)*(exp(n*Ln((1+sqrt(5))/2))+exp(n*Ln(abs(1-sqrt(5))/2)));
    Ausgabe.Items.Add(Format('%0.0f',[Erg]));
   end;
  Screen.Cursor:=crDefault;
 end;

procedure TFibonaccifolge.WahlClick(Sender: TObject);
begin
 if Wahl.ItemIndex=0 then Eingabe.MaxValue:=40
 else Eingabe.MaxValue:=1000
end;

end.
