unit Hofstadter;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, ExtCtrls;

type
  THofFolge = class(TForm)
    Eingabe: TSpinEdit;
    LabelN: TLabel;
    LabelFn: TLabel;
    Rechne: TButton;
    Tiefe: TLabel;
    LabelTiefe: TLabel;
    Wahl: TRadioGroup;
    FiboBild: TImage;
    Ausgabe: TListBox;
    procedure RechneClick(Sender: TObject);
    function Hof(AN:Integer):Integer;
    procedure WahlClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  HofFolge: THofFolge;

implementation

{$R *.DFM}
{$R+,Q+}
var count:Extended;

function THofFolge.Hof(AN:Integer):Integer;
 begin
  Count:=Count+1.0;
  if AN<3 then Hof:=1 else Hof:=Hof(AN-Hof(AN-1))+Hof(AN-Hof(AN-2))
 end;

procedure THofFolge.RechneClick(Sender: TObject);
 var K,N:Integer;
     F:Array of Integer;
     Erg:Extended;
 begin
  N:=Eingabe.Value;Count:=0;Ausgabe.Clear;
  Screen.Cursor:=crHourGlass;
  if Wahl.ItemIndex=0 then
   begin
    LabelTiefe.Visible:=True;
    Tiefe.Visible:=True;
    Erg:=Hof(N);
    Ausgabe.Items.Add(Format('%0.0f',[Erg]));
    Tiefe.Caption:=Format('%0.0f',[Count]);
   end
  else
   begin
    LabelTiefe.Visible:=False;
    Tiefe.Visible:=False;
    SetLength(F,N+1);
    F[1]:=1;
    Ausgabe.Items.Add(Format('%6.0d',[F[1]]));
    F[2]:=1;
    Ausgabe.Items.Add(Format('%6.0d',[F[2]]));
    for K:=3 to N do
     begin
      F[K]:=F[K-F[K-1]]+F[K-F[K-2]];
      Ausgabe.Items.Add(Format('%6.0d',[F[K]]));
     end;
   end;
  Screen.Cursor:=crDefault;
 end;

procedure THofFolge.WahlClick(Sender: TObject);
begin
 if Wahl.ItemIndex=0 then Eingabe.MaxValue:=50
 else Eingabe.MaxValue:=1000
end;

end.
