unit Einstellungen;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Spin;

type
  TParameterDialog = class(TForm)
    GrenzenLabel: TStaticText;
    LowSterben: TSpinEdit;
    HighSterben: TSpinEdit;
    LowLeben: TSpinEdit;
    HighLeben: TSpinEdit;
    MinTodLabel: TStaticText;
    MaxTodLabel: TStaticText;
    MinGeburtLabel: TStaticText;
    MaxGeburtLabel: TStaticText;
    Verz: TSpinEdit;
    Verzoegerung: TStaticText;
    TodLabel: TStaticText;
    Geburt: TStaticText;
    ButtonOk: TButton;
    MaxGeneration: TSpinEdit;
    Generationen: TStaticText;
    Einzeln: TCheckBox;
    procedure ButtonOkClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  ParameterDialog: TParameterDialog;

implementation

uses Life1;

{$R *.dfm}

 procedure TParameterDialog.ButtonOkClick(Sender: TObject);
  var Version:Integer;
  begin
   Life.LowTod:=LowSterben.Value;
   Life.HighTod:=HighSterben.Value;
   Life.LowGeb:=LowLeben.Value;
   Life.HighGeb:=HighLeben.Value;
   Life.LifeBewegung.Interval:=Verz.Value;
   Life.MaxOzzi:=MaxGeneration.Value;
   if Einzeln.Checked then
    begin
     Life.Einzelschritt.Enabled:=True;
     Life.Back.Enabled:=True;Life.Vorwaerts.Enabled:=True;
     Life.Start.Enabled:=False;
     SetLength(Life.Ozzi,Life.MaxOzzi+1);
     end
   else
    begin
     Life.Einzelschritt.Enabled:=False;
     Life.Back.Enabled:=False;Life.Vorwaerts.Enabled:=False;
     Life.Start.Enabled:=True;
    end;
   with Life do
    Version:=1000*LowTod+100*HighTod+10*LowGeb+HighGeb;
   Life.Caption:='Conway'+''''+'s Life     Version '+IntToStr(Version);
   close
  end;

end.
