unit BSort;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin;

type
  TBubble = class(TForm)
    SpinEditN: TSpinEdit;
    LabelN: TLabel;
    SpinEditV: TSpinEdit;
    LabelV: TLabel;
    SpinEditB: TSpinEdit;
    LabelB: TLabel;
    Generator: TButton;
    Sortieren: TButton;
    Unsortiert: TListBox;
    Sortiert: TListBox;
    procedure GeneratorClick(Sender: TObject);
    procedure SortierenClick(Sender: TObject);
  private
   Liste:Array of Integer; // dynamisches Array
   N:Integer;
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Bubble: TBubble;

implementation

{$R *.DFM}
{$R+,Q+}
 Procedure TBubble.GeneratorClick(Sender: TObject);
  Var Von,Bis,K,L:Integer;
  Begin
   N:=SpinEditN.Value;Von:=SpinEditV.Value;Bis:=SpinEditB.Value;
   Unsortiert.Clear;Sortiert.Clear;L:=Length(SpinEditB.Text);
   SetLength(Liste,N); // Speicherplatz fr Liste definieren, 0 bis N-1 Pltze
   For K:=0 To N-1 Do
    Begin
     Liste[K]:=Random(Bis-Von)+1;
     Unsortiert.Items.Add(Format('%'+IntToStr(L)+'d',[Liste[K]]));
    End;
  End;

 Procedure TBubble.SortierenClick(Sender: TObject);
  Var K,L,T:Integer;
      Fertig:Boolean;
  Begin
   L:=Length(SpinEditB.Text);
   Repeat
    Fertig:=True;
    For K:=0 To N-2 Do
     If Liste[K]>Liste[K+1] Then
      Begin
       T:=Liste[K];
       Liste[K]:=Liste[K+1];
       Liste[K+1]:=T;Fertig:=False
      End
   Until Fertig;
   For K:=0 To N-1 Do
    Sortiert.Items.Add(Format('%'+IntToStr(L)+'d',[Liste[K]]));
  End;

End.
