unit Fakultaetsberechnung;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TFakultaet = class(TForm)
    LabelN: TLabel;
    Zahl: TEdit;
    Start: TButton;
    LabelE: TLabel;
    Ausgabe: TListBox;
    Anzahl: TLabeledEdit;
    LabelZeit: TLabel;
    LabelSek: TLabel;
    procedure StartClick(Sender: TObject);
    function TimeSekunden:Extended;
  private
    { Private-Deklarationen }
   Fak:Array of Extended;
  public
    { Public-Deklarationen }
  end;

var
  Fakultaet: TFakultaet;

implementation

{$R *.DFM}
{$R+,Q+}

 function TFakultaet.TimeSekunden:Extended;
  var H, M, S, MS : Word;
  begin
   DecodeTime(Now,H,M,S,MS);
   TimeSekunden:=3600.0*H+60.0*M+1.0*S+MS/1000
  end;

 procedure TFakultaet.StartClick(Sender: TObject);
  const Null='00000000000000000000';
  var Bis,I,k,N,BL,Range,Ziffern:Integer;
      Zeit,Teiler,U,LT,L,H:Extended;
      ZahlStr:String;
  begin
   N:=StrToInt(Zahl.Text);
   Ausgabe.Clear;
   LT:=LN(10);BL:=9;
   Teiler:=1;
   for I:=1 to BL do Teiler:=10*Teiler;
   L:=0;
   for I:=1 to N do L:=L+LN(I);
   L:=L/LT;
   Range:=Trunc(L/BL)+1;
   SetLength(Fak,Range);
   Fak[0]:=1;
   for I:=1 to Range-1 do Fak[I]:=0;
   L:=0;Screen.Cursor:=crHourGlass;
   Zeit:=TimeSekunden;
   for I:=1 to N do
    Begin
     L:=L+LN(I)/LT;
     Bis:=Trunc(L/BL);
     U:=0;
     for K:=0 to Bis do
      Begin H:=Fak[K]*I+U;U:=Int(H/Teiler);Fak[K]:=H-U*Teiler End
    End;
   Zeit:=TimeSekunden-Zeit;
   Screen.Cursor:=crDefault;
   LabelE.Caption:=IntToStr(N)+'!';
   Ausgabe.Items.Add(Format('%10.0f',[Fak[Range-1]]));
   for I:=Range-2 downto 0 do
    begin
     Str(Fak[I]:0:0,ZahlStr);
     ZahlStr:=copy(Null+ZahlStr,Length(Null+ZahlStr)-BL+1,BL);
     ZahlStr:=Format('%10s',[ZahlStr]);
     Ausgabe.Items.Add(ZahlStr);
    end;
   Ziffern:=BL*(Range-1)+Trunc(LN(Fak[Range-1])/LT)+1;
   Anzahl.Text:=Format('%0d',[Ziffern]);
   LabelSek.Caption:=Format('%0.2f',[Zeit])+' sek.';
  end;

end.
