unit LangPrimTest;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, LangZahlRechnen, ExtCtrls;

type
  TLPrimTest = class(TForm)
    LabelExpo: TLabel;
    SpinEditN: TSpinEdit;
    Ausgabe: TListBox;
    Rechne: TButton;
    LabelErg: TLabel;
    LabelRZ: TLabel;
    Daten: TRadioGroup;
    LabelZahl: TLabel;
    Eingabe: TEdit;
    procedure RechneClick(Sender: TObject);
    procedure DatenClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  LPrimTest: TLPrimTest;

implementation

{$R *.DFM}
 function TimeSekunden:Extended;
  var H, M, S, MS : Word;
  begin
   DecodeTime(Now,H,M,S,MS);
   TimeSekunden:=3600.0*H+60.0*M+1.0*S+MS/1000
  end;

 procedure TLPrimTest.RechneClick(Sender: TObject);
  var K,N:Integer;
      P,Z,Q,R,ZWEI,ZAHL,TEILER,WURZEL:TFeld;
      LP,LZ,LQ,LR,LZWEI,LZAHL,LTEILER,LWURZEL:WORD;
      F,Prim:Boolean;
      TimeZahl,FT:String;
      T_Sek:Extended;
  begin
   Ausgabe.Items.Clear;
   if Daten.ItemIndex=1 then
    begin
     N:=SpinEditN.Value;
     LANGINT(P,LP,1);LANGINT(Z,LZ,2);
     FOR K:=1 TO N DO LANGMUL(P,LP,P,Z,LP,LZ);
     LANGINT(Z,LZ,1);LANGSUB(ZAHL,LZAHL,P,Z,LP,LZ,F,FT);
    end
   else LangRead(Eingabe.Text,Zahl,LZahl);
   LANGINT(TEILER,LTEILER,3);
   LangAusgabe(Ausgabe,Zahl,LZahl);
   T_Sek:=TimeSekunden;Screen.Cursor:=crHourGlass;
   LANGINT(ZWEI,LZWEI,2);LANGWURZEL(WURZEL,LWURZEL,ZAHL,LZAHL);
   Ausgabe.Items.Add('');Ausgabe.Items.Add('Wurzel=');
   LangAusgabe(Ausgabe,Wurzel,LWurzel);
   PRIM:=TRUE;
   WHILE LANGKLEINER(TEILER,WURZEL,LTEILER,LWURZEL) AND PRIM DO
    BEGIN
     LANGDIVISION(Q,R,LQ,LR,ZAHL,TEILER,LZAHL,LTEILER);
     IF (LR=1) AND (R[1]=0) THEN PRIM:=NOT PRIM
     ELSE LANGADD(TEILER,LTEILER,TEILER,ZWEI,LTEILER,LZWEI,F,Ft)
    END;
   Screen.Cursor:=crDefault;
   T_Sek:=TimeSekunden-T_Sek;Str(T_Sek:0:2,TimeZahl);
   LabelRZ.Caption:='Rechenzeit='+TimeZahl+' Sek.';
   if Prim then
    begin
     LabelErg.Font.Color:=clLime;
     LabelErg.Caption:='Primzahl!';
    end
   else
    begin
     LabelErg.Font.Color:=clRed;
     LabelErg.Caption:='keine Primzahl!';
     Ausgabe.Items.Add('');Ausgabe.Items.Add('Teiler sind:');
     LangAusgabe(Ausgabe,Teiler,LTeiler);
     LANGDIVISION(Q,R,LQ,LR,ZAHL,TEILER,LZAHL,LTEILER);
     Ausgabe.Items.Add('und');
     LangAusgabe(Ausgabe,Q,LQ);
    end
  end;

 procedure TLPrimTest.DatenClick(Sender: TObject);
  begin
   if Daten.ItemIndex=0 then
    begin
     LabelExpo.Visible:=False;
     SpinEditN.Visible:=False;
     LabelZahl.Visible:=True;
     Eingabe.Visible:=True;
    end
   else
    begin
     LabelExpo.Visible:=True;
     SpinEditN.Visible:=True;
     LabelZahl.Visible:=False;
     Eingabe.Visible:=False;
    end
  end;

end.
