unit Info;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, ShellApi;

type
  TInfoBox = class(TForm)
    Panel1: TPanel;
    RegelnIcon: TImage;
    RegelIcon2: TImage;
    LabelProdukt: TLabel;
    LabelVersion: TLabel;
    Label1: TLabel;
    Internet: TLabel;
    MailTo: TLabel;
    procedure InternetClick(Sender: TObject);
    procedure InternetMouseEnter(Sender: TObject);
    procedure InternetMouseLeave(Sender: TObject);
    procedure MailToClick(Sender: TObject);
    procedure MailToMouseEnter(Sender: TObject);
    procedure MailToMouseLeave(Sender: TObject);
    procedure ButtonOkClick(Sender: TObject);
    procedure Label1Click(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  InfoBox: TInfoBox;

implementation
uses About;
{$R *.dfm}

 procedure TInfoBox.InternetClick(Sender: TObject);
  begin
   ShellExecute(Application.Handle,'open','http://www.meister-fiete.de',nil,nil,sw_normal);
  end;

 procedure TInfoBox.InternetMouseEnter(Sender: TObject);
  begin
   Internet.Font.Style:=[fsBold, fsUnderline];
   Internet.Font.Color:=clLime;
   Internet.Font.Size:=14;
  end;

 procedure TInfoBox.InternetMouseLeave(Sender: TObject);
  begin
   Internet.Font.Style:=[fsBold];
   Internet.Font.Color:=clAqua;
   Internet.Font.Size:=12;
  end;

 procedure TInfoBox.MailToClick(Sender: TObject);
  begin
  ShellExecute(Application.Handle,'open','mailto:Hal@meister-fiete.de?subject=Probieren',nil,nil,sw_normal);
  end;

 procedure TInfoBox.MailToMouseEnter(Sender: TObject);
  begin
   MailTo.Font.Style:=[fsBold, fsUnderline];
   MailTo.Font.Color:=clLime;
   MailTo.Font.Size:=14;
  end;

 procedure TInfoBox.MailToMouseLeave(Sender: TObject);
  begin
   MailTo.Font.Style:=[fsBold];
   MailTo.Font.Color:=clWhite;
   MailTo.Font.Size:=12;
  end;

 procedure TInfoBox.ButtonOkClick(Sender: TObject);
  begin close end;

 procedure TInfoBox.Label1Click(Sender: TObject);
  begin Autor.ShowModal end;

end.
