{$R+,G+,Q+}
PROGRAM SCHABLONE;

 USES CRT;

 CONST MAX=20;LOCH=0;MASSIV=1;

 TYPE TBRETT=ARRAY[1..MAX,1..MAX]OF BYTE;
      TBRIEF=ARRAY[1..MAX,1..MAX]OF CHAR;

 VAR BRIEF:TBRIEF;
     BRETT:TBRETT;
     Z,S,LT,K,BG:BYTE;
     T:STRING;
     TASTE:CHAR;

 PROCEDURE NORMAL;
  BEGIN TEXTCOLOR(YELLOW) END;
 PROCEDURE HELL;
  BEGIN TEXTCOLOR(WHITE) END;
 PROCEDURE BLAU;
  BEGIN TEXTCOLOR(BLUE) END;

 PROCEDURE WARTE;
  VAR C:CHAR;
  BEGIN
   GOTOXY(2,24);WRITE('Drcke die Leertaste : ');
   REPEAT C:=READKEY UNTIL C=' ';
   GOTOXY(2,24);CLREOL
  END;

 PROCEDURE DREHEN(VAR NEU:TBRETT;ALT:TBRETT);
  VAR Z,S:BYTE;
  BEGIN
   FOR Z:=1 TO BG DO
    FOR S:=1 TO BG DO NEU[S,BG+1-Z]:=ALT[Z,S]
  END;

 PROCEDURE AUSGABE(KARTE:TBRETT);
  VAR Z,S:BYTE;
  BEGIN
   FOR Z:=1 TO BG DO
    BEGIN
     GOTOXY(2,3+Z);
     FOR S:=1 TO BG DO
      BEGIN
       IF KARTE[Z,S]=MASSIV THEN BEGIN BLAU;WRITE('');NORMAL END;
       IF KARTE[Z,S]=LOCH THEN BEGIN HELL;WRITE('');NORMAL END;
      END;
    END;
   WARTE
  END;

 PROCEDURE EINGEBEN(VAR KARTE:TBRETT);
  VAR K,S,Z,N:BYTE;
      TASTE:CHAR;
  BEGIN
   FILLCHAR(KARTE,SIZEOF(KARTE),MASSIV);{ Schablone ist massiv }
   WRITE('Standardschablone (J/N)');
  REPEAT TASTE:=UPCASE(READKEY) UNTIL TASTE IN['J','N'];WRITELN(TASTE);
  IF TASTE='J' THEN
   BEGIN
    KARTE[1,3]:=LOCH;KARTE[1,4]:=LOCH;KARTE[2,5]:=LOCH;KARTE[3,2]:=LOCH;KARTE[3,4]:=LOCH;
    KARTE[5,1]:=LOCH;KARTE[5,4]:=LOCH;KARTE[5,6]:=LOCH;KARTE[6,1]:=LOCH;EXIT
   END;
   WRITE('Anzahl der Lcher : ');READLN(N);
   FOR K:=1 TO N DO
    BEGIN
     WRITE(K,'-te Loch    Zeile  : ');READLN(Z);
     WRITE(K,'-te Loch    Spalte : ');READLN(S);
     KARTE[Z,S]:=LOCH
    END;
   CLRSCR;AUSGABE(KARTE)
  END;

 PROCEDURE VORGABE(VAR KARTE:TBRETT);
  VAR ALT,Z,S,N,DREHEN,D,GRENZE,K:BYTE;
      CODE:LONGINT;
      FELD:TBRETT;
  BEGIN
   FILLCHAR(KARTE,SIZEOF(KARTE),MASSIV);{ Schablone ist massiv }
   FELD:=KARTE;
   WRITE('Deine Kennung : ');READLN(CODE);
   RANDSEED:=CODE;GRENZE:=BG DIV 2;
   N:=LT DIV 4;IF LT MOD 4>0 THEN INC(N);
   FOR K:=1 TO N DO { Anzahl der Lcher }
    BEGIN
     REPEAT
      Z:=RANDOM(GRENZE)+1;S:=RANDOM(GRENZE)+1;
     UNTIL FELD[Z,S]=1;
     FELD[Z,S]:=LOCH;DREHEN:=RANDOM(3)+1;
     FOR D:=1 TO DREHEN DO
      BEGIN ALT:=Z;Z:=S;S:=BG+1-ALT END;
     KARTE[Z,S]:=LOCH
    END
  END;

 PROCEDURE ZEIGE(KARTE:TBRIEF);
  VAR Z,S:BYTE;
  BEGIN
   NORMAL;
   FOR Z:=1 TO BG DO
    BEGIN
     GOTOXY(42,3+Z);
     FOR S:=1 TO BG DO WRITE(KARTE[Z,S]:2);
    END;
   WARTE
  END;

 PROCEDURE VERSCHLUESSELN(NACHRICHT:STRING;L:BYTE;VAR CODEBRIEF:TBRIEF);
  VAR WO,K,Z,S:BYTE;
  BEGIN
   WO:=0;
   FOR K:=1 TO 4 DO
    BEGIN
     FOR Z:=1 TO BG DO
      FOR S:=1 TO BG DO
       IF BRETT[Z,S]=LOCH THEN
        BEGIN
         INC(WO);
         IF WO>L THEN BREAK;
         BRIEF[Z,S]:=NACHRICHT[WO]
        END;
     DREHEN(BRETT,BRETT);
    END;
  END;

 BEGIN { of Main }
  CLRSCR;
{  WRITE('Dein Text : ');READLN(T);}
  T:='KOMM UND BRING JULEE NACH FARNSWORTH';
{  T:='JULEE MIT STALLKNECHT DURCHGEBRANNT';}
  LT:=LENGTH(T);BG:=TRUNC(SQRT(LT));
  IF FRAC(SQRT(LT))>0 THEN INC(BG);
  IF ODD(BG) THEN INC(BG);
  WRITE('Schablone (e)ingeben oder (v)orgeben lassen : ');
  REPEAT TASTE:=UPCASE(READKEY) UNTIL TASTE IN['E','V'];WRITELN(TASTE);
  IF TASTE='E' THEN EINGEBEN(BRETT) ELSE VORGABE(BRETT);
  VERSCHLUESSELN(T,LT,BRIEF);
  AUSGABE(BRETT);
{   FOR K:=1 TO 3 DO
   BEGIN
    DREHEN(BRETT,BRETT);
    FOR Z:=1 TO BG DO
     FOR S:=1 TO BG DO
      IF BRETT[Z,S]=LOCH THEN BRIEF[Z,S]:=LOCH;
    AUSGABE(BRETT);
   END;}
  ZEIGE(BRIEF)
 END.
