unit Sickern;
interface
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Spin;
type
  TGrafikPB = class(TForm)
    Start: TButton;
    Boden: TSpinEdit;
    LabelBoden: TLabel;
    LabelErgebnis: TLabel;
    Ausgabe: TPaintBox;
    procedure StartClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var  GrafikPB: TGrafikPB;

implementation

{$R *.DFM}
{$R+,Q+}
 FUNCTION DURCHGESICKERT(Y:Integer;Farbe:TColor):BOOLEAN;
  VAR X:Integer;
  BEGIN
   DURCHGESICKERT:=FALSE;
   FOR X:=0 TO GrafikPB.Ausgabe.ClientWidth DO
    IF GrafikPB.Ausgabe.Canvas.Pixels[X,Y]=FARBE THEN
     BEGIN DURCHGESICKERT:=TRUE;EXIT END;
  END;

procedure TGrafikPB.StartClick(Sender: TObject);
 const FMax=18;
       Farben:Array[1..FMax]of TColor=
                     (clAqua, clBlack, clBlue, clDkGray, clFuchsia, clGray,
                      clGreen, clLime, clLtGray,clMaroon, clNavy, clOlive,
                      clPurple, clRed, clSilver,clTeal, clWhite ,clYellow);
 Var MaxX,MaxY,X,Y,XA,XE,P:integer;
     Farbe:TColor;
     Rect:TRect;
 begin
  LabelErgebnis.Caption:='Ergebnis : ';
  Randomize;Y:=1;Farbe:=Farben[Random(FMax)+1];// Punktfarbe
  MaxX:=Ausgabe.ClientWidth;MaxY:=Ausgabe.ClientHeight;
  Ausgabe.Canvas.Brush.Color:=Farben[Random(FMax)+1];// Hintergrundfarbe
  Rect.Left:=0;Rect.Top:=0;
  Rect.Right:=Ausgabe.Width;Rect.Bottom:=Ausgabe.Height;
  Ausgabe.Canvas.FillRect(Rect);// Formular fllen
  XA:=MaxX DIV 4;IF NOT ODD(XA) THEN INC(XA);
  XE:=3*(MaxX DIV 4);IF NOT ODD(XE) THEN DEC(XE);
  P:=StrToInt(Boden.Text);
  Screen.Cursor:=crHourGlass;
  FOR X:=XA TO XE DO
   IF ODD(X) THEN Ausgabe.Canvas.Pixels[X,Y]:=Farbe;
  REPEAT
   FOR X:=0 TO MaxX DO
    IF Ausgabe.Canvas.Pixels[X,Y]=FARBE THEN
     BEGIN
      IF RANDOM(100)+1>P THEN
       BEGIN
        IF X>0 THEN Ausgabe.Canvas.Pixels[X-1,Y+1]:=FARBE;
        IF X<Ausgabe.ClientWidth THEN Ausgabe.Canvas.Pixels[X+1,Y+1]:=FARBE;
       END
     END;
   INC(Y)
  UNTIL (Y=MaxY) OR NOT DURCHGESICKERT(Y,Farbe);
  Screen.Cursor:=crDefault;
  IF Y=MaxY THEN LabelErgebnis.Caption:='Ergebnis : Das l ist leider durchgesickert!'
  ELSE LabelErgebnis.Caption:='Ergebnis : Das l ist glcklicherweise NICHT durchgesickert!';
 end;

end.

