unit Info;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ShellApi;

type
  TInfoBox = class(TForm)
    Panel1: TPanel;
    ImageLevel: TImage;
    ProductName: TLabel;
    Version: TLabel;
    Copyright: TLabel;
    Hinweis: TLabel;
    Internet: TLabel;
    MailTo: TLabel;
    OKButton: TButton;
    procedure OKButtonClick(Sender: TObject);
    procedure InternetClick(Sender: TObject);
    procedure InternetMouseEnter(Sender: TObject);
    procedure InternetMouseLeave(Sender: TObject);
    procedure MailToMouseEnter(Sender: TObject);
    procedure MailToMouseLeave(Sender: TObject);
    procedure MailToClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  InfoBox: TInfoBox;

implementation

{$R *.dfm}

 procedure TInfoBox.OKButtonClick(Sender: TObject);
  begin close end;

 procedure TInfoBox.InternetClick(Sender: TObject);
  begin
   ShellExecute(Application.Handle,'open','http://www.meister-fiete.de',nil,nil,sw_normal);
  end;

 procedure TInfoBox.InternetMouseEnter(Sender: TObject);
  begin
   Internet.Font.Style:=[fsBold, fsUnderline];
   Internet.Font.Color:=clLime;
   Internet.Font.Size:=14;
  end;

 procedure TInfoBox.InternetMouseLeave(Sender: TObject);
  begin
   Internet.Font.Style:=[fsBold];
   Internet.Font.Color:=clBlack;
   Internet.Font.Size:=10;
  end;

 procedure TInfoBox.MailToMouseEnter(Sender: TObject);
  begin
   MailTo.Font.Style:=[fsBold, fsUnderline];
   MailTo.Font.Color:=clLime;
   MailTo.Font.Size:=14;
  end;

 procedure TInfoBox.MailToMouseLeave(Sender: TObject);
  begin
   MailTo.Font.Style:=[fsBold];
   MailTo.Font.Color:=clBlack;
   MailTo.Font.Size:=10;
  end;

 procedure TInfoBox.MailToClick(Sender: TObject);
  begin
   ShellExecute(Application.Handle,'open','mailto:Hal@meister-fiete.de?subject=Probieren',nil,nil,sw_normal);
  end;

end.
